\section{Linux, Python, Bash}

\subsection{Red Team}
Associated with offensive security. Focused on penetration testing of different systems. Imitate real-world attacks that can hit a company or an organization. A common practices is to hire an external red team that is unaware of the internal infrastructure.

\begin{description}
	\item[1. Think outside the box] \hfill \\
	Constantly find new tools and techniques. Go against rules and legality while following white hat techniques. Show people the flaws in their systems have.
	\item[2. Deep knowledge of systems] \hfill \\
	Have deep knowledge of computer systems, protocols and libraries and known methodologies. Follow trends in technology. Have knowledge of networks, servers and databases. 
	\item[3. Software development] \hfill \\
	Know how to develop your own tools. Lots of practice with writing software. 
	\item[4. Penetration testing] \hfill \\
	Identify vulnerabilities and any potential threats.
	\item[5. Social engineering] \hfill \\
\end{description}

\subsection{Blue Team}
Associated with defensive cybersecurity. Assessment of network security and identification of any possible vulnerabilities. They find ways to defend, change and re-group defence mechanism and procedure in order to build response strategies around them. They’re continuously involved to strengthen the entire digital security infrastructure, using software like an IDS (intrusion detection system) that provides them with an ongoing analysis of unusual and suspicious activity.

\begin{description}
	\item[1. Organized and detail-oriented] \hfill \\
	Detail-oriented mindset to prevent leaving gaps in a company’s security infrastructure.
	\item[2. Cybersecurity analysis and threat profile] \hfill \\
	Assess the security of a company or an organization. Create a risk or threat profile
	\item[3. Hardening techniques] \hfill \\
	Implement technical hardening techniques. Reduce the attack surface hackers may exploit.
	\item[4. Knowledge of detection systems] \hfill \\
	Be familiar with software applications that allow tracking of the network for any unusual and possibly malicious activity. Follow all network traffic, packet filtering, existing firewalls.
	\item[5. SIEM] \hfill \\
	SIEM, or Security Information and Event Management, is a software that offers real-time analysis of security events.
\end{description}

\subsection{Linux Basics}

\subsubsection{Linux User and Group Accounts}
To be able to run command in sudo, a user has to be added to the sudo group. 

\begin{verbatim}
root@kali# useradd -m username
root@kali# chsh -s /bin/bash username
root@kali# passwd username
root@kali# usermod -a -G sudo username
\end{verbatim}
Creating and adding users into groups.
\begin{verbatim}
root@kali# sudo groupa -g 10000 engineering
root@kali# sudo groupa -g 10001 sales
root@kali# usermod -a -G engineering user1
root@kali# user mod -a -G sales user2
\end{verbatim}

\subsubsection{Linux File Permissions}
Linux knows three different basic permissions: read, write, execute. These can be applied to any type of files or to directories. Files and folders can be displayed with the command: ls -la. The access rights are based on three bits.

\begin{figure}[h!]
  \center
  \includegraphics[width=10cm]{linuxfileper}
  \caption{Linux File Permissions}
\end{figure}

\subsubsection{Networking}
Please don not use ifconfig anymore! ip -c -brie a ist the newest shit! Setting up a physical network.

\begin{verbatim}
root@kali# sudo ifup ens160
root@kali# sudo ip addr add dev ens160 10.6.5.50/24
\end{verbatim}

\subsubsection{DNS Zone transfer}
The dig command is useful for performing DNS queries on specific DNS servers. It can be thought of as an more powerful version of the host command. DNS Zone transfer is the process where a DNS server passes a copy of part of its database (which is called a "zone") to another DNS server. In a basic DNS Zone Transfer Attack you just pretend you are a slave and ask the master for a copy of the zone records.

\subsubsection{Enabling SSH Access}
Secure Shell is designed to replace unsecure remote communication operations, such as the telnet, ftp, rlogin, rsh, rcp, and rexec commands/protocols. The primary issue with previous communication methods is that these methods send data across the network in plain text, rather than encrypted format. SSH has become such a standard in Linux that almost all distributions include both the client and server software by default. The configuration file for the SSH server is the \/etc\/ssh\/sshd\_config file.

\subsubsection{Process Logs for Incident Response}
The Linux kernel assigns a unique process ID (PID) to each process sequentially, as the processes are created.

\begin{description}
	\item[top (atop,htop] \hfill \\
	The \textbf{top (atop,htop)} command: Just like in Windows or any other operating system, looking for orphan, zombie, and suspicious processes is one of the tasks in Linux forensics. If you find a process running with open network sockets that doesn’t show up on a similar system, there may be something suspicious on that system. As an ethical hacker, the log files can be a trail to your target’s activities and identity. This is why you need to know what information they can gather, as well as what can be gathered about your own actions and methods in order to hide that evidence. Linux uses a daemon called syslogd to automatically log events on your computer. \\
	\item[rsyslog.conf Logging Rules] \hfill \\
	The facility keyword references the program, such as mail, kernel, or lpr, whose messages are being logged. The priority tells the system what kinds of messages to log. Codes are listed from lowest priority, starting at debug, to highest priority, ending at panic. the priority is *, messages of all priorities are logged.
	\item[shred] \hfill \\
	The –f option to force permission to shred auth files. The –n option with the desired number of times to overwrite. After the path of the file we want to shred, we include the wildcard asterisk so we’re shredding not just the auth.log file, but also any logs that have been created with logrotate, such as auth.log.1, auth.log.2, and so on.
\end{description}

\begin{verbatim}
root@kali# shred -f -n 15 /var/log/auth.log*
\end{verbatim}

\subsubsection{DD command}
The dd command is use for a bit-by-bit copy of files and folders.

\begin{figure}[h!]
  \center
  \includegraphics[width=0.75\textwidth]{ddcommand}
  \caption{DD Command Refernece}
\end{figure}

\subsubsection{Scheduled Tasks}

\begin{verbatim}
root@kali# ls /etc/cron
\end{verbatim}

\begin{figure}[h!]
  \center
  \includegraphics[width=\textwidth]{cron}
  \caption{Linux Cron Job}
\end{figure}

\subsubsection{Service Startup Scripts}
\begin{verbatim}
root@kali# ls /etc/init.d/
\end{verbatim}

\subsubsection{Command History}
\begin{verbatim}
cat .bash_history
\end{verbatim}

\subsection{Linux Firewalls and Intrusion Preventions Systems}
You can customize the behavior of netfilter to do various tasks and improve security. We will cover a set of common commands one may want to use when administrating a Linux host. IPS -> Snort, Security Onion, RedHunt Linux.

\begin{verbatim}
//Flush all existing Rules
root@kali# iptables -F

//Block all Traffic -> This will kill all communication
root@kali# iptables -P INPUT DROP
root@kali# iptables -P FORWARD DROP
root@kali# iptables -P OUTPUT DROP

//Allow SSH traffic from specific resources
root@kali# iptables -A INPUT -p udp -i eht0 --sport 53 -j ACCEPT
root@kali# iptables -A OUTPUT -p udp -o eht0 --sport 53 -j ACCEPT

//Allowing Pin
root@kali# iptables -A OUTPUT -p icmp --icmp-type echo-request -j ACCEPT
root@kali# iptables -A INPUT -p icmp --icmp-type echo-reply -j ACCEPT

//Showing the status of the firewall
iptables -L -n -n --line-numbers
\end{verbatim}

\subsection{Reverse Bind Shells with Netcat}
%todo add description of netcat

\begin{figure}[h!]
  \center
  \includegraphics[width=8cm]{bindshell}
  \caption{Bind Shell}
\end{figure}

\begin{figure}[h!]
  \center
  \includegraphics[width=8cm]{reverseshell}
  \caption{Reverse Shell}
\end{figure}

\subsubsection{Netcat Reverse Shells}
We can see all the input the user makes and can also copy files etc.

\begin{figure}[h!]
  \center
  \includegraphics[width=\textwidth]{netcatreverseshell}
  \caption{Netcat Reverse Shell}
\end{figure}

\subsubsection{Post Exploitation Activities using Python}
\textbf{Pythonic Web Server} Invoke a web server on port 1337 and serve up the current working directory of the file system for download. Usage scenario: Moving files.

\begin{verbatim}
//Python 2.x
python -m SimpleHTTPServer 1337
//Python 3.x
python3 -m http.server 1337
\end{verbatim} 

\textbf{Pythonic Web Client} Fetch a file or web page and write it into a file. Usage scenario: Download additional tools to a compromised machine using only built-in Python features. \\
\textbf{Python Debugger}  This imports a Python file and runs the debugger automatically. Usage scenario: Debugging your python-based malware for post-exploitation. \\
\textbf{Raw shell to Terminal} Turns a raw shell gained through an exploit into a terminal session. Usage scenario: After exploiting a system and getting a raw shell, this
command allows pen testers to utilize various linux commands that require a terminal session (sudo, vi, …). \\
\textbf{Using Python to do a Reverse Shell} Create a reverse Netcat-like shell connection. Usage scenario: Post-exploitation to create a stable shell.

\subsubsection{Scapy}
Scapy is a Python utility that allows you to send, sniff, dissect, and forge IP packets. You can create tools that can probe, scan or attack networks. Scapy is a very powerful interactive packet manipulation program. Also used to create attack signature for IDS/IPS systems.
